/* -----------------------------------------------------------------------

   Copyright (C) 2004 Mariusz "Manio" Bialonczyk

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your option)
   any later version.

   ----------------------------------------------------------------------- */

#include "Connection.h"

int Connection::IncRings()
{
	return ++iRings;
}

tm* Connection::GetTime()
{
	return rtime;
}

int Connection::GetRings()
{
	return iRings;
}

void Connection::UDP_Send()
{
	ServAddr.sin_family = AF_INET;
	ServAddr.sin_addr.s_addr = inet_addr(OLO_IP_ADDR);
	ServAddr.sin_port = htons(CID_UDP_PORT);

	iServFD=socket(AF_INET,SOCK_DGRAM,0);
	if (iServFD<0)
		lprintf("Connection::UDP_Send: error creating socket for UDP send\n");
	if ( (connect(iServFD, (struct sockaddr*)&ServAddr, sizeof(ServAddr))) < 0 )
		lprintf("Connection::UDP_Send: error connecting to %s\n",OLO_IP_ADDR);

	lprintf("Connection::NotifyOlo: sending caller info to olo via UDP port %d\n",CID_UDP_PORT);
	if ( (write(iServFD, szSendBuffer, (strlen(szSendBuffer)+1))) <= 0 )
		lprintf("Connection::NotifyOlo: sending failed\n");
}

bool Connection::NotifyOlo()
{
	bool bFound=false;
	//4 is because char* olo_callers have 4 callers to check - change it if needed
	for (int i=0;i<4;i++)	//searching
	{
		if (strstr(LCDcallerinfo.szLCDLine1,olo_callers[i]) || strstr(LCDcallerinfo.szLCDLine2,olo_callers[i]))
		{
			bFound=true;
			break;
		}
	}

	if (!bFound)		//not match - exit
		return false;

	if (*LCDcallerinfo.szLCDLine1==0)
	{
		if (snprintf(szSendBuffer,SEND_BUFF_SIZE,"time: %s\r\n%s",LCDcallerinfo.szTime,LCDcallerinfo.szLCDLine2)==-1)
		{
			lprintf("Connection::NotifyOlo failed: send buffer size truncated\n");
			return false;
		}
	}
	else
	{
		if (snprintf(szSendBuffer,SEND_BUFF_SIZE,"time: %s\r\n%s %s",LCDcallerinfo.szTime,LCDcallerinfo.szLCDLine1,LCDcallerinfo.szLCDLine2)==-1)
		{
			lprintf("Connection::NotifyOlo failed: send buffer size truncated\n");
			return false;
		}
	}
	return true;
}

char* Connection::GetNumberBuffAddr()
{
	return szNumber;
}

void Connection::ResetCounters()
{
	iRings=1;
	FillDateTimeNow();
}

void Connection::FillDateTimeNow()
{
	time (&thetime);
	rtime = localtime (&thetime);
}
