#ifndef LCD_H
#define LCD_H

#include <errno.h>	//errno, EAGAIN
#include <netdb.h>	//socket, connect, shutdown
#include <arpa/inet.h>	//AF_INET, PF_INET, SOCK_STREAM
#include <string.h>	//bzero
#include <unistd.h>	//close()
#include <fcntl.h>	//O_RDWR, O_NOCTTY, O_SYNC
#include "main.h"

#define LCD_LINE_WIDTH	20
#define LCD_BUFF_SIZE	100
#define TIME_STR_SIZE	9
#define RINGS_STR_SIZE	10
#define LCDPORT		13666
#define SERVERNAME	"localhost"

struct CallerInfo
{
	char szLCDLine1[LCD_LINE_WIDTH+1];
	char szLCDLine2[LCD_LINE_WIDTH+1];
	char szTime[TIME_STR_SIZE];
};

extern CallerInfo LCDcallerinfo;

class LCD
{
private:
	int iSock;
	int iCallers;				//connections since reset
	bool bVisible;
	char szBuff[LCD_BUFF_SIZE];
	char szRings[RINGS_STR_SIZE];
public:
	LCD();
	~LCD();
	int sock_connect (char *host, unsigned short int port);
	bool Connect();
	void Prepare();				//making a screen
	unsigned short int NoData();
	unsigned short int Add();		//new data to LCD screen
	unsigned short int ResetCallers();	//iCallers=0
	void FormatTime(tm* rtime);
	void Clear();				//clear screen
	void UpdateRings(int iRings);
	int SockSendBuff();			//Send/receive lines of text
	bool SockConnect();
	int SockClose();
};

#endif	// LCD_H
