#ifndef MODEM_H
#define MODEM_H

#include <fcntl.h>	//O_RDWR, O_NOCTTY, O_SYNC
#include <unistd.h>	//close()
#include <string.h>	//bzero
#include <termios.h>	//TCIOFLUSH
#include "main.h"

#define MODEM_DEVICE		"/dev/modem"
#define MODEM_BUFF_SIZE		255
#define PARSE_READ_ERROR	1
#define PARSED_RING		2
#define PARSED_CALLERID		3
#define PARSED_NOTHING		4

const char szATZ[]		="ATZ\r\n";
const char szInitString1[]	="ATB0S91=0F4#CID=1\r\n";	//formatted
const char szInitString2[]	="ATB0S91=0F4#CID=2\r\n";	//RAW
const char szDeInitString[]	="ATS91=10F0\r\n";

class Modem
{
private:
	const static bool bFormat=1;	//#CID format (0=formatted; 1=RAW)
	int fd;
	int iRead;			//debug: read() returned value
 	char szModemBuffer[MODEM_BUFF_SIZE];
	char *pCIDNumberStart;		//pointer to the beginning of the number
	bool bUnlisted;			//determine if detected number is unlisted
public:
	Modem();			//constructor
	void Dial(char *szNumber);
	~Modem();
	void Open();
	void Close();
	void Init();
	bool Opened();
	void DeInit();
	bool BlockingRead();		//blocking read
	int Parse();
	void GetCIDNumber(char*);	//get and copy pure number
};

#endif	// MODEM_H
