/* -----------------------------------------------------------------------

   Copyright (C) 2004 Mariusz "Manio" Bialonczyk

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your option)
   any later version.

   ----------------------------------------------------------------------- */

#include <fcntl.h>	//O_RDONLY
#include <unistd.h>	//open(), close()
#include <string.h>	//strerror()
#include "main.h"

int get_clipd_pid()
{
	int lfp;
	char buff[10];
	if ((lfp = open(LOCK_FILE, O_RDONLY)) < 0)
	{
		fprintf(stderr,"Error: Cannot open clipd lock file: %s\nIt seems that clipd is not running now\nexiting...\n",strerror(errno));
		exit(1);
	}
	read(lfp,&buff,strlen(buff));
	close(lfp);
	return (atoi(buff));
}

void print_usage()
{
		printf("Usage: clipcmd dial <number>\n");
}

int main(int argc, char **argv)
{
	int fifo;	//fifo descriptor
	if (argc!=3)
	{
		print_usage();
		exit(1);
	}

	if (strcmp(argv[1],"dial")!=0)
	{
		printf("Unknown command: '%s'\n",argv[1]);
		print_usage();
		exit(1);
	}
	if ((kill(get_clipd_pid(), SIGUSR2)) == -1)
	{
		fprintf(stderr,"Error: Cannot send SIGUSR2 signal to clipd: %s\n",strerror(errno));
		exit(1);
	}
	if ((fifo = open(FIFO_DEVICE, O_WRONLY)) < 0)
	{
		fprintf(stderr,"Error: Cannot open fifo device '%s': %s\n",FIFO_DEVICE,strerror(errno));
		exit(1);
	}
	printf("Dialing number: '%s'\n",argv[2]);
	write(fifo,argv[2],strlen(argv[2]));
	close(fifo);
	return 0;
}
